using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using nMail;

namespace csmail
{
    public partial class FormUnite : Form
    {
        public FormUnite()
        {
            InitializeComponent();

            PartNo = 1;
        }

		private string Id;
		private int PartNo;

        private void buttonAdd_Click(object sender, EventArgs e)
        {
			if(openFileDialog.ShowDialog() == DialogResult.OK) 
			{
				StreamReader reader = new System.IO.StreamReader(openFileDialog.FileName);
				string header = reader.ReadToEnd();
				reader.Close();

				using(nMail.Attachment attach = new nMail.Attachment()) {
					int no = attach.GetId(header);
					if((no == 0 && listFile.Items.Count == 0) || (PartNo == no)) {
						if(no == 1) {
							Id = attach.PartId;
						}
						if(no == 0 || Id == attach.PartId) {
							listFile.Items.Add(openFileDialog.FileName);
							PartNo++;
							buttonSave.Enabled = true;
						} else {
							MessageBox.Show("ꂽ[f[^v܂", "csmail", MessageBoxButtons.OK, MessageBoxIcon.Error);
						}
					}
					else if(listFile.Items.Count == 0 && attach.GetHeaderField("Content-Type:", header).IndexOf("text/html") >= 0) {
						listFile.Items.Add(openFileDialog.FileName);
						buttonSave.Enabled = true;
					} 
					else 
					{
						if(no < 0) {
							MessageBox.Show("ꂽ[݂܂", "csmail", MessageBoxButtons.OK, MessageBoxIcon.Error);
						} else {
							MessageBox.Show("ꂽ[f[^̏Ԃ܂", "csmail", MessageBoxButtons.OK, MessageBoxIcon.Error);
						}
					}
				}
			}

        }

        private void buttonSave_Click(object sender, EventArgs e)
        {
			if(textFolder.Text == "") 
			{
				return;
			}
			if(listFile.Items.Count == 0) 
			{
				return;
			}
			using(nMail.Attachment attach = new nMail.Attachment()) 
			{
				attach.Path = textFolder.Text;
				try 
				{
                    nMail.Options.EnableDecodeHeader();
					nMail.Options.EnableDecodeBody();
					for(int no = 0 ; no < listFile.Items.Count ; no++) 
					{
						StreamReader reader = new System.IO.StreamReader((string)listFile.Items[no]);
						string header = reader.ReadToEnd();
						reader.Close();
						attach.Add(header);
					}
					attach.Save();
					if(attach.HtmlFile != "") 
					{
						// I
						if(MessageBox.Show(textFolder.Text + " ɓYtt@C " + attach.FileName + " WJ܂B\r\n\r\n:" + attach.Subject + "\r\n{:\r\n" + attach.Body + "\r\nHTML t@C " + attach.HtmlFile + " J܂H\r\n(EBXꍇ܂BӉ)", "₢킹", MessageBoxButtons.YesNo) == DialogResult.Yes)
						{
							Process.Start(attach.Path + "\\" + attach.HtmlFile);
						}
					} 
					else 
					{
						// I
						MessageBox.Show(textFolder.Text + " ɓYtt@C " + attach.FileName + " WJ܂B\r\n\r\n:" + attach.Subject + "\r\n{:\r\n" + attach.Body);
					}
					Close();
				}
				catch(nMailException nex) 
				{
					if(nex.ErrorCode == nMail.Attachment.ErrorFileOpen) 
					{
						MessageBox.Show("Ytt@CI[vł܂B");
					} 
					else if(nex.ErrorCode == nMail.Attachment.ErrorInvalidNo) 
					{
						MessageBox.Show("ꂽ[̏ԂȂAYȂt@CĂ܂B");
					} 
					else if(nex.ErrorCode == nMail.Attachment.ErrorPartial) 
					{
						MessageBox.Show("ꂽ[SđĂ܂");
					}
				} 
				catch(Exception ex) 
				{
					Debug.WriteLine(ex.Message);
				}
			}
		}

        private void buttonFolder_Click(object sender, EventArgs e)
        {
			if(folderBrowserDialog.ShowDialog() == DialogResult.OK) 
			{
				textFolder.Text = folderBrowserDialog.SelectedPath;
			}
        }

        private void FormUnite_Load(object sender, EventArgs e)
        {
			textFolder.Text = Directory.GetCurrentDirectory();
        }
    }
}